      SUBROUTINE ISAWIG(MT)
C
C  Writes a table of SUSY particle (and top quark) properties
C  and decays in a format suitable for reading by HERWIG.
C  Call at end of SSRUN or SUGRUN.
C  MT = top mass used in ISASUSY or ISASUGRA.
C  Other parameters passed via common /SUGMG/ & /SSMODE/
C 
      IMPLICIT NONE
C  Masses:
C     MSS( 1) = glss     MSS( 2) = upl      MSS( 3) = upr
C     MSS( 4) = dnl      MSS( 5) = dnr      MSS( 6) = stl
C     MSS( 7) = str      MSS( 8) = chl      MSS( 9) = chr
C     MSS(10) = b1       MSS(11) = b2       MSS(12) = t1
C     MSS(13) = t2       MSS(14) = nuel     MSS(15) = numl
C     MSS(16) = nutl     MSS(17) = el-      MSS(18) = er-
C     MSS(19) = mul-     MSS(20) = mur-     MSS(21) = tau1
C     MSS(22) = tau2     MSS(23) = z1ss     MSS(24) = z2ss
C     MSS(25) = z3ss     MSS(26) = z4ss     MSS(27) = w1ss
C     MSS(28) = w2ss     MSS(29) = hl0      MSS(30) = hh0
C     MSS(31) = ha0      MSS(32) = h+
      COMMON /SUGMG/ MSS(32),GSS(26),MGUTSS,GGUTSS,AGUTSS
      REAL MSS,GSS,MGUTSS,GGUTSS,AGUTSS
      SAVE /SUGMG/
C  Decays
C          MXSS                 = maximum number of modes
C          NSSMOD               = number of modes
C          ISSMOD               = initial particle
C          JSSMOD               = final particles
C          GSSMOD               = width
C          BSSMOD               = branching ratio
      INTEGER MXSS
      PARAMETER (MXSS=1000)
      COMMON/SSMODE/NSSMOD,ISSMOD(MXSS),JSSMOD(5,MXSS),GSSMOD(MXSS)
     $,BSSMOD(MXSS)
      INTEGER NSSMOD,ISSMOD,JSSMOD
      REAL GSSMOD,BSSMOD
      SAVE /SSMODE/
C
      REAL GEV2PS,MT,WIDTH,LTIM,MASS,SPIN
      DATA GEV2PS/6.582122E-13/
      CHARACTER*8 DNAME(3)
      CHARACTER*60 FNAME
      INTEGER IDEC(3),I,J,K,L,M,ID,JD,IH,IP,NSS,NPP
      DATA IH,IP/1,2/
C  SUSY HERWIG names, charge & PDG codes, ISAJET ID & mass codes
      PARAMETER (NSS=64,NPP=NSS+27)
      CHARACTER*8 HWNAME(NPP)
      INTEGER ICH(NSS),IMISA(NSS),NDEC(NSS),IDHW(NPP),IDISA(NPP),
     & IDPDG(NPP)
      DATA NDEC/NSS*0/
      DATA (HWNAME(I),ICH(I),IDPDG(I),IDISA(I),IMISA(I),I=1,24)/
     &'SSDL    ',-1, 1000001, 22, 4,'SSUL    ', 2, 1000002, 21, 2,
     &'SSSL    ',-1, 1000003, 23, 6,'SSCL    ', 2, 1000004, 24, 8,
     &'SSB1    ',-1, 1000005, 25,10,'SST1    ', 2, 1000006, 26,12,
     &'SSDLBR  ', 1,-1000001,-22, 4,'SSULBR  ',-2,-1000002,-21, 2,
     &'SSSLBR  ', 1,-1000003,-23, 6,'SSCLBR  ',-2,-1000004,-24, 8,
     &'SSB1BR  ', 1,-1000005,-25,10,'SST1BR  ',-2,-1000006,-26,12,
     &'SSDR    ',-1, 2000001, 42, 5,'SSUR    ', 2, 2000002, 41, 3,
     &'SSSR    ',-1, 2000003, 43, 7,'SSCR    ', 2, 2000004, 44, 9,
     &'SSB2    ',-1, 2000005, 45,11,'SST2    ', 2, 2000006, 46,13,
     &'SSDRBR  ', 1,-2000001,-42, 5,'SSURBR  ',-2,-2000002,-41, 3,
     &'SSSRBR  ', 1,-2000003,-43, 7,'SSCRBR  ',-2,-2000004,-44, 9,
     &'SSB2BR  ', 1,-2000005,-45,11,'SST2BR  ',-2,-2000006,-46,13/
      DATA (HWNAME(I),ICH(I),IDPDG(I),IDISA(I),IMISA(I),I=25,48)/
     &'SSEL-   ',-1, 1000011, 32,17,'SSNUEL  ', 0, 1000012, 31,14,
     &'SSMUL-  ',-1, 1000013, 34,19,'SSNUMUL ', 0, 1000014, 33,15,
     &'SSTAU1- ',-1, 1000015, 36,21,'SSNUTL  ', 0, 1000016, 35,16,
     &'SSEL+   ', 1,-1000011,-32,17,'SSNUELBR', 0,-1000012,-31,14,
     &'SSMUL+  ', 1,-1000013,-34,19,'SSNUMLBR', 0,-1000014,-33,15,
     &'SSTAU1+ ', 1,-1000015,-36,21,'SSNUTLBR', 0,-1000016,-35,16,
     &'SSER-   ',-1, 2000011, 52,18,'SSNUER  ', 0, 2000012, 51, 0,
     &'SSMUR-  ',-1, 2000013, 54,20,'SSNUMUR ', 0, 2000014, 53, 0,
     &'SSTAU2- ',-1, 2000015, 56,22,'SSNUTR  ', 0, 2000016, 55, 0,
     &'SSER+   ', 1,-2000011,-52,18,'SSNUERBR', 0,-2000012,-51, 0,
     &'SSMUR+  ', 1,-2000013,-54,20,'SSNUMRBR', 0,-2000014,-53, 0,
     &'SSTAU2+ ', 1,-2000015,-56,22,'SSNUTRBR', 0,-2000016,-55, 0/
      DATA (HWNAME(I),ICH(I),IDPDG(I),IDISA(I),IMISA(I),I=49,NSS-2)/
     &'GLUINO  ', 0, 1000021, 29, 1,'NTLINO1 ', 0, 1000022, 30,23,
     &'NTLINO2 ', 0, 1000023, 40,24,'NTLINO3 ', 0, 1000025, 50,25,
     &'NTLINO4 ', 0, 1000035, 60,26,'CHGINO1+', 1, 1000024, 39,27,
     &'CHGINO2+', 1, 1000037, 49,28,'CHGINO1-',-1,-1000024,-39,27,
     &'CHGINO2-',-1,-1000037,-49,28,'HIGGSL0 ', 0,      26, 82,29,
     &'HIGGSH0 ', 0,      35, 83,30,'HIGGSA0 ', 0,      36, 84,31,
     &'HIGGS+  ', 1,      37, 86,32,'HIGGS-  ',-1,     -37,-86,32/
C  non-SUSY HERWIG names & codes, PDG & ISAJET codes
      DATA (HWNAME(I),IDHW(I),IDPDG(I),IDISA(I),I=NSS-1,NPP)/
     &'TQRK    ',  6,  6,  6,'TBAR    ', 12, -6, -6,
     &'DQRK    ',  1,  1,  2,'UQRK    ',  2,  2,  1,
     &'SQRK    ',  3,  3,  3,'CQRK    ',  4,  4,  4,
     &'BQRK    ',  5,  5,  5,'DBAR    ',  7, -1, -2,
     &'UBAR    ',  8, -2, -1,'SBAR    ',  9, -3, -3,
     &'CBAR    ', 10, -4, -4,'BBAR    ', 11, -5, -5,
     &'E-      ',121, 11, 12,'NU_E    ',122, 12, 11,
     &'MU-     ',123, 13, 14,'NU_MU   ',124, 14, 13,
     &'TAU-    ',125, 15, 16,'NU_TAU  ',126, 16, 15,
     &'E+      ',127,-11,-12,'NU_EBAR ',128,-12,-11,
     &'MU+     ',129,-13,-14,'NU_MUBAR',130,-14,-13,
     &'TAU+    ',131,-15,-16,'NU_TAUBR',132,-16,-15,
     &'GLUON   ', 13, 21,  9,'GAMMA   ', 59, 22, 10,
     &'W+      ',198, 24, 80,'W-      ',199,-24,-80,
     &'Z0/GAMA*',200, 23, 90/
C  Tell HERWIG where to store SUSY particles
      DO I=1,57
        IDHW(I)=400+I
      ENDDO
      DO I=58,62
        IDHW(I)=145+I
      ENDDO
C
      PRINT *,' Enter ISAWIG output file name (in single quotes):'
      READ *, FNAME
      OPEN(IH,FILE=FNAME,STATUS='NEW',FORM='FORMATTED')
C
C  Output SUSY particle + top quark table
C
      WRITE (IH,'(I4)') NSS
      DO I=1,NSS
        IF (I.LT.63) THEN
          MASS=0.
          IF (IMISA(I).NE.0) MASS=MSS(IMISA(I))
          SPIN=0.
          IF (I.GT.48.AND.I.LT.58) SPIN=0.5
        ELSE
C t and tbar
          MASS=MT
          SPIN=0.5
          ICH(I)=2
          IF (I.EQ.64) ICH(I)=-2
        ENDIF
C  Compute lifetime in ps
        ID=ABS(IDISA(I))
        WIDTH=0.
        DO J=1,NSSMOD
          IF (ISSMOD(J).EQ.ID) THEN
            NDEC(I)=NDEC(I)+1
            WIDTH=WIDTH+GSSMOD(J)
          ENDIF
        ENDDO
        IF (WIDTH.NE.0.) THEN
          LTIM=GEV2PS/WIDTH
        ELSE
          LTIM=1E30
        ENDIF
        WRITE (IH,1) IDHW(I),HWNAME(I),IDPDG(I),ICH(I),
     &  MASS,LTIM,SPIN
      ENDDO
    1 FORMAT(I5,X,A8,I9,I3,F12.4,E15.5,F7.2)
C 
C  Output decay modes
C
      DO I=1,NSS
        WRITE (IH,'(I4)') NDEC(I)
        IF (NDEC(I).NE.0) THEN
          WRITE (IP,*)
          ID=ABS(IDISA(I))
          DO J=1,NSSMOD
            IF (ISSMOD(J).EQ.ID) THEN
C  Translate decay products
              DO K=1,3
                L=JSSMOD(K,J)
                IF (L.EQ.0) THEN
                  IDEC(K)=0
                  DNAME(K)='        '
                ELSE
                  IF (IDISA(I).LT.0) L=-L
                  DO M=1,91
                    IF (IDISA(M).EQ.L) THEN
                      IDEC(K)=IDHW(M)
                      DNAME(K)=HWNAME(M)
                      GO TO 10
                    ENDIF
                  ENDDO
C   Antiparticle=particle
                  L=-L
                  DO M=1,91
                    IF (IDISA(M).EQ.L) THEN
                      IDEC(K)=IDHW(M)
                      DNAME(K)=HWNAME(M)
                      GO TO 10
                    ENDIF
                  ENDDO
                  PRINT *,' Unknown ISAJET ID =',L
                  IDEC(K)=20
                  DNAME(K)='****    '
   10             CONTINUE
                ENDIF
              ENDDO
              JD=IDHW(I)
              IF (JD.EQ.6.OR.JD.EQ.12) THEN
C   Special for t and tbar
                IF (IDEC(1).GT.120.AND.IDEC(1).LT.133) THEN
C   Leptonic decay: ISAJET order is wrong for M.E. calcn
                  WRITE (IH,11) JD,BSSMOD(J),
     &            100,IDEC(2),IDEC(1),IDEC(3),0,0
                ELSE
C   Nonleptonic decay
                  WRITE (IH,11) JD,BSSMOD(J),
     &            100,(IDEC(K),K=1,3),0,0
                ENDIF
              ELSE
                WRITE (IH,11) JD,BSSMOD(J),
     &          0,(IDEC(K),K=1,3),0,0
              ENDIF
              WRITE (IP,12) HWNAME(I),(DNAME(K),K=1,3),BSSMOD(J)
   11         FORMAT(I6,E16.8,6I6)
   12         FORMAT(1X,A8,'  -->   ',3(A8,2X),1P,E12.4)
            ENDIF
          ENDDO
        ENDIF
      ENDDO   
      END
